/* 
   CSE142, 99 Winter
   Homework 5
   Valentine's Day
  
   Author:     Andrew Morton
   Student ID: 9824921
   Section:    AG
*/
#include "gp142.h"
#include <math.h>
#include <stdlib.h>
#include <time.h>

/*#define TRUE    		1
#define FALSE   		0*/

/*A status for each button, allowing highlights upon selection
  and allowing function calls for each as appropriate*/
#define STATUS_BACKROUND_COLOR 0
#define STATUS_CHANGE_TYPE 1
#define STATUS_ADD_SHAPE 2
#define STATUS_ADD_TEXT 3
#define STATUS_CHANGE_COLOR 4
#define STATUS_SELECT_OBJECT 5
#define STATUS_SELECTED 6

/* Configure the appearance of the buttons on the menu bar 
   by setting the number of pixels of button height and width*/
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	6
#define SELECTED_COLOR  RED

/* Position of the card in the window */
#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH +60)
#define PAGE_LLY (-GP142_YMAX + 100)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY - 50)

/* For many of the GP142 functions, a line width of
   zero means to fill the shape being drawn.*/
#define FILL 0
#define NOFILL 1

/*Array limits*/
#define MAX_SHAPES 25
#define MAX_TEXTS 25
#define MAX_OBJECTS MAX_SHAPES + MAX_TEXTS
/*x, y, color, object type*/
#define DATA_POINTS 4
/*Indexes the data being stored in the second part of the array*/
#define O_XCOORD 0
#define O_YCOORD 1
#define O_COLOR 2
#define O_TYPE 3

/* These are the different objects, 5 shapes, 5 messages*/
#define SHAPE_HEART 0
#define SHAPE_STAR  1
#define SHAPE_SMILEY 2
#define SHAPE_ARROW 3
#define SHAPE_CUBE 4
#define MSG1 5
#define MSG2 6
#define MSG3 7
#define MSG4 8
#define MSG5 9

#define CLENGTH 30

/*Possible places for mouse clicks*/
#define CLICK_BUTTON 1  /* You clicked on SOME button (doesn't say which one)*/
#define CLICK_CARD 2    /* You clicked in the card area */
#define CLICK_OUTSIDE 3	/* You clicked outside the card area, not on a button*/	


/*******************  FUNCTION PROTOTYPES **************************/

/* Drawing functions */
void DrawBlankScreen (void);
void DrawButtons(int last_button);
void DrawCard (int background_color, int status, int shape_count, int text_count,
			   int objects_array[MAX_OBJECTS][DATA_POINTS], int *angle);
void DrawShape(int objects_array[MAX_OBJECTS][DATA_POINTS], int i, int *angle);
void DrawMsg(int objects_array[MAX_OBJECTS][DATA_POINTS], int i);
void DrawHeart (int x, int y, int color);
void DrawStar (int x, int y, int color);
void DrawSmiley(int x, int y, int color);
void DrawArrow(int x, int y, int color);
void DrawCube (int x, int y, int color, int *angle);
void DrawMsg1 (int x, int y, int color);
void DrawMsg2 (int x, int y, int color);
void DrawMsg3 (int x, int y, int color);
void DrawMsg4 (int x, int y, int color);
void DrawMsg5 (int x, int y, int color);

/*Calculates which object was selected*/
void Select_Object(int x, int y, int *selected_object, int *shape_count,
				  int *text_count, int *status,
				  int objects_array [MAX_OBJECTS][DATA_POINTS]);

/* Mouse click handling functions */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *shape_count, int *text_count,
					  int *selected_object,
					  int objects_array[MAX_OBJECTS][DATA_POINTS]);
int ClassifyMouseClick(int mouse_x, int mouse_y);
/*Handles which button has been selected*/
void HandleButton(int x, int y, int *background_color,
				  int *status, int *selected_object,
				  int objects_array[MAX_OBJECTS][DATA_POINTS]);
				  
/* Add a shape to the card. */
void AddShape(int x, int y, int *status, int *shape_count,
			  int *text_count, int *selected_object,
			  int objects_array[MAX_OBJECTS][DATA_POINTS]);
void AddMsg(int x, int y, int *status, int *text_count,
		    int *shape_count, int *selected_object,
			int objects_array[MAX_OBJECTS][DATA_POINTS]);

/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
 *initialize them, and to contain the "event loop," which constantly looks 
 *to see if an event has happened, and then processes the event by calling 
 *an appropriate function. An example of an event is a mouse click.
 */
int main(void)
{
	int quit = FALSE;              /* becomes TRUE to exit program */
	int mouse_x, mouse_y;          /* coordinates of a mouse click */
	char key_hit;                  /* which key was hit            */
	
	/*The objects array, this contains information for each object on
	the screen, x and y coordinates, color, and type*/
	int objects_array[MAX_OBJECTS][DATA_POINTS];
	
	/*Indexes which object in the array is being selected*/
	int selected_object=0;
	
	/*variables and their default values*/
	int background_color = YELLOW;
	int status = STATUS_ADD_SHAPE;
	
	/*Counters for how many shapes, and how many messges are on the card*/
	int shape_count=0;
	int text_count=0;
	
	int angle = 0;
	
	
	int last_button = -1;           /* Keep track of the last button clicked.
	                                   This would be usefull when highlighting
	                                   the last button the user clicked */

	int event; /*the most recent GP142 event*/
	
	time_t t; /*needed only when initializing a random number generator*/
	

	/*
	 * INITIALIZATIONS
	 */
	srand (time(&t));	    /* Seed the random number generator.*/
	

	/* These GP142 initializations don't need to be changed */
	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	
	GP142_clear();	        /* This will clear the window & paint it white. */
	GP142_animate(ANI_RUN); /* Enable periodic events                       */
	
	
	
	/*
	 * The main event loop:
	 * --- ---- ----- -----
	 * wait for the next user action, such as a mouse click or keyboard
	 * keypress, or a periodic update event (allowing us to display the
	 * next frame of an animation -- not used directly in this program)
	 * and call the appropriate function to handle it.  Repeat this until 
	 * the user signals "quit".
	 */
	 
	while (!quit) {  /*this is the famous "event loop" */
		
		/*start by redrawing everything */
		DrawBlankScreen ();
		DrawCard (background_color, status, shape_count, text_count,
		objects_array, &angle);
		DrawButtons(status);	  /* Show the buttons...*/ 
		GP142_printfXY (RED, -125, 225, 14,
			"Your Personalized Valentine's Day Card Creator!");
		GP142_printfXY (RED, 200, -245, 10,
			"Type Q to quit");
		
		/*Wait for something to happen */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
		
		/* Something just happened.  Figure out what it was, and react 
		   appropriately. */
		switch (event) {
		case GP142_QUIT:
			quit = TRUE;           /* set flag to terminate loop           */
			break;
			
		case GP142_KBD:  /*A key was pressed */
			/*Allows user to end program with keystroke*/
			if (key_hit == 'q' || key_hit == 'Q')
				quit = TRUE;
			
		case GP142_MOUSE:
			/* A mouse click has occurred. Call the mouse handler to 
			   decide where the click was and react as needed. */
			HandleMouseClick(mouse_x, mouse_y, &background_color, &status, 
					         &shape_count, &text_count, &selected_object,
							 objects_array);
			break;
			
		case GP142_PERIODIC:
			/*An events has occurred simply because some time has passed,*/
			/*not currently used in the program*/		
			break;

		default:
			break;
			
		}  /*end switch */
		
	}  /* end event loop */
	
	
	/*
	 * WRAP-UP
	 */
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/
/* 
 * For a blank screen just draw a white rectangle that covers the whole
 * GP142 window.
 */
void DrawBlankScreen (void) {
	int font_size = 14;

	GP142_rectangleXY (WHITE,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);

} /*end DrawBlankScreen */


/*Draws the buttons*/
void DrawButtons(int last_button)
{

	char b_labels [NUM_BUTTONS][50] = {
		"Background\ncolor", "Next Option", "Add Shape",
		"Add Message", "Change Color", "Select New Object"
	};
	
	int i, text_offset = -GP142_XMAX + 6, font_size = 10;
	int y, label_y;
	
	/* draw rectangles and labels for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		y = GP142_YMAX - i * BUTTON_HEIGHT;
		
		GP142_rectangleXY(BLACK,
			-GP142_XMAX + 4,
			y - 2,
			-GP142_XMAX + BUTTON_WIDTH,
			y - BUTTON_HEIGHT - 2, 1);
		
		label_y = y - BUTTON_HEIGHT/2;
		
		if (i == last_button)
			GP142_printfXY(SELECTED_COLOR, text_offset, label_y,
						   font_size, b_labels[i]);	
		else
			GP142_printfXY(BLACK, text_offset, label_y,
						   font_size, b_labels[i]);	
	}	
}


/*
 * Render (draw) the page and all its contents.
 */
void DrawCard (int background_color, int status, int shape_count, int text_count,
			   int objects_array[MAX_OBJECTS][DATA_POINTS], int *angle)
{
	int font_size = 14;
	int i = 0;
	
	/*
	 * Draw the background of the card.
	 */
	GP142_rectangleXY (background_color,
		PAGE_LLX, PAGE_LLY,
		PAGE_LLX+ PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT,
		FILL);
	
	/*Draw another shape or message if possible*/
	while (i<shape_count+text_count){
		if (objects_array[i][3]<5) {
		DrawShape(objects_array, i, angle);
		}
		else if (objects_array[i][3]>=5) {
		DrawMsg(objects_array, i);
		}
		i++;
	}

	
	
	/* Write an appropriate status message below the background*/
	switch (status) {
	case STATUS_BACKROUND_COLOR:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
			"Click button to change backround color");
		break;
	case STATUS_ADD_SHAPE:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
			"Click on the card to add a shape");
		break;
	case STATUS_CHANGE_TYPE:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size-3,
			"Object selected. Click button to cycle through options");
		break;
	case STATUS_ADD_TEXT:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size,
			"Click on the card to add a message");
			break;
	case STATUS_CHANGE_COLOR:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
			"Click button to change color");
		break;
	case STATUS_SELECT_OBJECT:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size,
			"Object Selection Mode, click near an object to select it");
		break;
	case STATUS_SELECTED:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size,
			"Object selected, click on card move, or click button");
		break;
	default:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
			"Status error -- notify programmer");
		break;
	} /*end switch */
	
	
} /*end DrawPage */


/*
 * Draw one shape.
 */
void DrawShape(int objects_array[MAX_OBJECTS][DATA_POINTS], int i, int *angle) {
	switch (objects_array[i][O_TYPE]) {
	case SHAPE_HEART:
		DrawHeart (objects_array[i][O_XCOORD],
		objects_array[i][O_YCOORD], objects_array[i][O_COLOR]);
		break;
	case SHAPE_STAR:
		DrawStar (objects_array[i][O_XCOORD],
		objects_array[i][O_YCOORD], objects_array[i][O_COLOR]);
		break;
	case SHAPE_SMILEY:
		DrawSmiley (objects_array[i][O_XCOORD],
		objects_array[i][O_YCOORD], objects_array[i][O_COLOR]);
		break;
	case SHAPE_ARROW:
		DrawArrow (objects_array[i][O_XCOORD],
		objects_array[i][O_YCOORD], objects_array[i][O_COLOR]);
		break;
	case SHAPE_CUBE:
		DrawCube (objects_array[i][O_XCOORD],
		objects_array[i][O_YCOORD], objects_array[i][O_COLOR], angle);
		break;
	default:
		/* Unknown shape selected */
		break;

	} /*end switch*/

}

/*Draws a text message on the card*/
void DrawMsg(int objects_array[MAX_OBJECTS][DATA_POINTS], int i) {

	switch (objects_array[i][O_TYPE]) {
	case MSG1:
		DrawMsg1 (objects_array[i][O_XCOORD],
		objects_array[i][O_YCOORD], objects_array[i][O_COLOR]);
		break;
	case MSG2:
		DrawMsg2 (objects_array[i][O_XCOORD],
		objects_array[i][O_YCOORD], objects_array[i][O_COLOR]);
		break;
	case MSG3:
		DrawMsg3 (objects_array[i][O_XCOORD],
		objects_array[i][O_YCOORD], objects_array[i][O_COLOR]);
		break;
	case MSG4:
		DrawMsg4 (objects_array[i][O_XCOORD],
		objects_array[i][O_YCOORD], objects_array[i][O_COLOR]);
		break;
	case MSG5:
		DrawMsg5 (objects_array[i][O_XCOORD],
		objects_array[i][O_YCOORD], objects_array[i][O_COLOR]);
		break;
	default:
		break;
	}
}

/*-----Draw Shape Functions-----*/

/*Draw a heart on the card. A heart will be made by two overlapping
circles and a triangle.*/
#define HEART_WIDTH 35
void DrawHeart (int x, int y, int color) {

	int h = (HEART_WIDTH/2) + (rand () %4);

	GP142_circleXY (color, x - h + 5, y, h);
	GP142_circleXY (color, x + h - 5, y, h);
	GP142_triangleXY (color, x- h*2 +5, y-5,
						x + h*2 -5, y-5,
						x, y - h*2 -5, FILL);

}


/*Draw a star on the card.*/
#define STARPOINTS 5
#define STARRADIUS 40
#define PI 3.1416
void DrawStar (int x, int y, int color) {

	int sp;
	double angle;
	int x1, y1;

	sp = STARPOINTS + (rand () %3);
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
		x1 = (int) (cos (angle) * STARRADIUS);
		y1 = (int) (sin (angle) * STARRADIUS);
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 1);

	}
}

/*Draw a smiley*/
void DrawSmiley(int x, int y, int color) {
	GP142_circleXY (color, x, y, 20);
	GP142_circleXY (color+1, x-5, y+5, 3);
	GP142_circleXY (color+1, x+5, y+5, 3);
	GP142_triangleXY(color+1, x-7, y-5, x+7, y-5, x, y-(rand () %12)-5, NOFILL);
}

/*Draw an arrow*/
void DrawArrow(int x, int y, int color) {
	GP142_lineXY (color, x, y, x+40, y, 3);
	GP142_lineXY (color, x+20, y, x+30, y-7, 3);
	GP142_lineXY (color, x+20, y, x+30, y+7, 3);
	GP142_lineXY (color, x+30, y, x+40, y-7, 3);
	GP142_lineXY (color, x+30, y, x+40, y+7, 3);
	GP142_lineXY (color, x+40, y, x+50, y-7, 3);
	GP142_lineXY (color, x+40, y, x+50, y+7, 3);
	GP142_triangleXY(color, x, y-5, x, y+5, x-5, y, FILL);
}

/*Draw the really cool 3-D (sort of) cube*/
/*As more cubes are placed on the screen, they move faster
  because they all increment the angle variable!*/
void DrawCube (int x, int y, int color, int *angle) {

int pointAx = (int)((int)x +
(double)cos(240*0.0174-*angle*0.0174)*(double)CLENGTH);

int pointAy = y + (int)(sin(240*0.0174-*angle*0.0174)*CLENGTH);
int pointBx = x + (int)(cos(*angle*0.0174)*CLENGTH);
int pointBy = y - (int)(sin(*angle*0.0174)*CLENGTH);
int pointCx = (pointBx) + (pointAx-x);
int pointCy = (pointBy) + (pointAy-y);
int pointDx = x;
int pointDy = y - CLENGTH;

GP142_lineXY (color, x, y, pointAx, pointAy, 1);
GP142_lineXY (color, x, y, pointBx, pointBy, 1);
GP142_lineXY (color, pointAx,pointAy,pointCx,pointCy,1);
GP142_lineXY (color, pointBx,pointBy,pointCx,pointCy,1);
GP142_lineXY (color, pointAx, pointAy, pointAx,pointAy-CLENGTH,1);
GP142_lineXY (color, pointBx, pointBy, pointBx,pointBy-CLENGTH,1);
GP142_lineXY (color, pointCx, pointCy, pointCx,pointCy-CLENGTH,1);
GP142_lineXY (color, pointAx, pointAy-CLENGTH, pointCx,pointCy-CLENGTH,1);
GP142_lineXY (color, pointBx, pointBy-CLENGTH, pointCx,pointCy-CLENGTH,1);
GP142_lineXY (color, x,y,pointDx,pointDy,1);
GP142_lineXY (color, pointDx,pointDy,pointAx,pointAy-CLENGTH,1);
GP142_lineXY (color, pointDx,pointDy,pointBx,pointBy-CLENGTH,1);

*angle = (*angle+1) % 360;
}

/*-----Message Drawing Functions-----*/
void DrawMsg1 (int x, int y, int color){
	int font_size=10;
	GP142_printfXY(color, x, y, font_size + (rand () %2),
	"Happy Valentine's Day!");
}

void DrawMsg2 (int x, int y, int color){
	int font_size=14;
	GP142_printfXY(color, x, y, font_size + (rand () %2),
	"Be Mine!");
}

void DrawMsg3 (int x, int y, int color){
	int font_size=14;
	GP142_printfXY(color, x, y, font_size + (rand () %2),
	"My Honeybunch!");
}

void DrawMsg4 (int x, int y, int color){
	int font_size=14;
	GP142_printfXY(color, x, y, font_size + (rand () %2),
	"My Guy!");
}

void DrawMsg5 (int x, int y, int color){
	int font_size=14;
	GP142_printfXY(color, x, y, font_size + (rand () %2),
	"My Girl!");
}


/*Mouse clicks occur in one of three regions of interest: on buttons, 
  on the card, or anywhere else.*/
int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return CLICK_BUTTON;
  else if (mouse_x >= PAGE_LLX && mouse_x < PAGE_LLX + PAGE_WIDTH
	  && mouse_y >= PAGE_LLY && mouse_y < PAGE_LLY + PAGE_HEIGHT)
    return CLICK_CARD;
  else
    return CLICK_OUTSIDE;

}


/*Decide where a mouse click occured, and react appropriately.*/
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *shape_count, int *text_count,
					  int *selected_object,
					  int objects_array[MAX_OBJECTS][DATA_POINTS])
{
	int mouse_click;
	mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
			
	if (mouse_click == CLICK_BUTTON) {
				
		/* A button has been clicked.  Call a function to handle it*/
		/* most of the variables passed as args will NOT change*/
		HandleButton(mouse_x, mouse_y, background_color, status, 
					 selected_object, objects_array);

	} else if (mouse_click == CLICK_CARD) {
		/* Add a shape, if there isn't one already */
		switch(*status) {
		case STATUS_ADD_SHAPE:
			AddShape(mouse_x, mouse_y, status, shape_count, text_count,
			   		 selected_object, objects_array);
			break;
		case STATUS_ADD_TEXT:
			AddMsg(mouse_x, mouse_y, status, text_count, shape_count,
			   		 selected_object, objects_array);
			break;
		case STATUS_SELECT_OBJECT:
			Select_Object(mouse_x, mouse_y, selected_object,
						 shape_count, text_count, status, objects_array);
			break;
		/*Allows user to move object around while in any of these modes*/
		case STATUS_CHANGE_COLOR:
		case STATUS_CHANGE_TYPE:
		case STATUS_SELECTED:
			objects_array[*selected_object][O_XCOORD] = mouse_x;
			objects_array[*selected_object][O_YCOORD] = mouse_y;
			break;
		default:
			break;
		}
	}
	/* Ignore any other mouse clicks */
}

/*Figure out which button was clicked, if any, and do the right 
 thing.*/
void HandleButton(int x, int y, int *background_color, int *status,
				   int *selected_object,
				  int objects_array[MAX_OBJECTS][DATA_POINTS])
{
	int buttonNum = 0;
	
	/* If we're outside of this area, we could not have clicked on
	* a button.
	*/
	if (x > -GP142_XMAX + BUTTON_WIDTH)  
		return ;	/*That's an error situation*/
	
	/* We know the mouse clicked in the column of buttons.
	Calculate which one. */
	buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* Change the background color */
		*background_color = (*background_color + 1) % MAX_COLORS;
		*status = STATUS_BACKROUND_COLOR;
		break;
	case 1:
		/* Change the type of the currently selected object */
		if (objects_array[*selected_object][O_TYPE]<5) {
		objects_array[*selected_object][O_TYPE]=
		(objects_array[*selected_object][O_TYPE]+1) % 5;
		}
		else if (objects_array[*selected_object][O_TYPE]>4) {
		objects_array[*selected_object][O_TYPE]=
		((objects_array[*selected_object][O_TYPE]+1) %5) + 5;
		}
		*status = STATUS_CHANGE_TYPE;
		break;
	case 2:
		/*Add another shape*/
		*status = STATUS_ADD_SHAPE;
		break;
	case 3:
		/*Add a text message*/
		*status = STATUS_ADD_TEXT;
		break;
	case 4:
		/*Change the color of the selected object*/
		objects_array[*selected_object][O_COLOR]=
		(objects_array[*selected_object][O_COLOR]+1) % MAX_COLORS;
		*status = STATUS_CHANGE_COLOR;
		break;
	case 5:
		/*Selects a new object*/
		*status = STATUS_SELECT_OBJECT;
		break;
	default:
		*status = 999;
		/*Bad news if this is ever reached! */
		break;
	}
}


/* If there's room for another shape, add it to the card. */
void AddShape(int x, int y, int *status, int *shape_count, int *text_count,
			  int *selected_object, int objects_array[MAX_OBJECTS][DATA_POINTS])
{
	int index = *text_count + *shape_count;
	if (*shape_count < MAX_SHAPES) {
	*status = STATUS_SELECTED;
	objects_array[index][O_XCOORD]=x;
	objects_array[index][O_YCOORD]=y;
	objects_array[index][O_COLOR]=6;
	objects_array[index][O_TYPE]=0;
	*selected_object = index;
	(*shape_count)++;
	}
}

/*If there is room for another message, add one*/
void AddMsg(int x, int y, int *status, int *text_count,int *shape_count,
			 int *selected_object, int objects_array[MAX_OBJECTS][DATA_POINTS])
{
    int index = *text_count + *shape_count;
	if (*text_count < MAX_TEXTS) {
	*status = STATUS_SELECTED;
	objects_array[index][O_XCOORD]=x;
	objects_array[index][O_YCOORD]=y;
	objects_array[index][O_COLOR]=6;
	objects_array[index][O_TYPE]=5;
	*selected_object = index;
	(*text_count)++;
	}
}

/*Selecting objects code*/
void Select_Object(int x, int y, int *selected_object, int *shape_count,
				  int *text_count, int *status,
				  int objects_array [MAX_OBJECTS][DATA_POINTS]) {
	int i;
	int x_dist;
	int y_dist;
	int new_dist;
	int close_point = 30000;
	for (i=0; i<(*text_count)+(*shape_count); i++) {
		x_dist = x - objects_array [i][O_XCOORD];
		y_dist = y - objects_array [i][O_YCOORD];
		new_dist = x_dist*x_dist+y_dist*y_dist;
		if((new_dist)<close_point &&
		   (new_dist)<200) {
			close_point = new_dist;
			*selected_object = i;
			*status = STATUS_SELECTED;
		}
	}
}